Code

eb5eebcd9685b399863e368ec674e2897f3650e4
[git.git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodules.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9    or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10    or: $dashless [--quiet] init [--] [<path>...]
11    or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12    or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13    or: $dashless [--quiet] foreach [--recursive] <command>
14    or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-parse-remote
18 require_work_tree
20 command=
21 branch=
22 force=
23 reference=
24 cached=
25 recursive=
26 init=
27 files=
28 nofetch=
29 update=
30 prefix=
32 # Resolve relative url by appending to parent's url
33 resolve_relative_url ()
34 {
35         remote=$(get_default_remote)
36         remoteurl=$(git config "remote.$remote.url") ||
37                 die "remote ($remote) does not have a url defined in .git/config"
38         url="$1"
39         remoteurl=${remoteurl%/}
40         sep=/
41         while test -n "$url"
42         do
43                 case "$url" in
44                 ../*)
45                         url="${url#../}"
46                         case "$remoteurl" in
47                         */*)
48                                 remoteurl="${remoteurl%/*}"
49                                 ;;
50                         *:*)
51                                 remoteurl="${remoteurl%:*}"
52                                 sep=:
53                                 ;;
54                         *)
55                                 die "cannot strip one component off url '$remoteurl'"
56                                 ;;
57                         esac
58                         ;;
59                 ./*)
60                         url="${url#./}"
61                         ;;
62                 *)
63                         break;;
64                 esac
65         done
66         echo "$remoteurl$sep${url%/}"
67 }
69 #
70 # Get submodule info for registered submodules
71 # $@ = path to limit submodule list
72 #
73 module_list()
74 {
75         git ls-files --error-unmatch --stage -- "$@" |
76         perl -e '
77         my %unmerged = ();
78         my ($null_sha1) = ("0" x 40);
79         while (<STDIN>) {
80                 chomp;
81                 my ($mode, $sha1, $stage, $path) =
82                         /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
83                 next unless $mode eq "160000";
84                 if ($stage ne "0") {
85                         if (!$unmerged{$path}++) {
86                                 print "$mode $null_sha1 U\t$path\n";
87                         }
88                         next;
89                 }
90                 print "$_\n";
91         }
92         '
93 }
95 #
96 # Map submodule path to submodule name
97 #
98 # $1 = path
99 #
100 module_name()
102         # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
103         re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
104         name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
105                 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
106        test -z "$name" &&
107        die "No submodule mapping found in .gitmodules for path '$path'"
108        echo "$name"
112 # Clone a submodule
114 # Prior to calling, cmd_update checks that a possibly existing
115 # path is not a git repository.
116 # Likewise, cmd_add checks that path does not exist at all,
117 # since it is the location of a new submodule.
119 module_clone()
121         path=$1
122         url=$2
123         reference="$3"
125         if test -n "$reference"
126         then
127                 git-clone "$reference" -n "$url" "$path"
128         else
129                 git-clone -n "$url" "$path"
130         fi ||
131         die "Clone of '$url' into submodule path '$path' failed"
135 # Add a new submodule to the working tree, .gitmodules and the index
137 # $@ = repo path
139 # optional branch is stored in global branch variable
141 cmd_add()
143         # parse $args after "submodule ... add".
144         while test $# -ne 0
145         do
146                 case "$1" in
147                 -b | --branch)
148                         case "$2" in '') usage ;; esac
149                         branch=$2
150                         shift
151                         ;;
152                 -f | --force)
153                         force=$1
154                         ;;
155                 -q|--quiet)
156                         GIT_QUIET=1
157                         ;;
158                 --reference)
159                         case "$2" in '') usage ;; esac
160                         reference="--reference=$2"
161                         shift
162                         ;;
163                 --reference=*)
164                         reference="$1"
165                         shift
166                         ;;
167                 --)
168                         shift
169                         break
170                         ;;
171                 -*)
172                         usage
173                         ;;
174                 *)
175                         break
176                         ;;
177                 esac
178                 shift
179         done
181         repo=$1
182         path=$2
184         if test -z "$path"; then
185                 path=$(echo "$repo" |
186                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
187         fi
189         if test -z "$repo" -o -z "$path"; then
190                 usage
191         fi
193         # assure repo is absolute or relative to parent
194         case "$repo" in
195         ./*|../*)
196                 # dereference source url relative to parent's url
197                 realrepo=$(resolve_relative_url "$repo") || exit
198                 ;;
199         *:*|/*)
200                 # absolute url
201                 realrepo=$repo
202                 ;;
203         *)
204                 die "repo URL: '$repo' must be absolute or begin with ./|../"
205         ;;
206         esac
208         # normalize path:
209         # multiple //; leading ./; /./; /../; trailing /
210         path=$(printf '%s/\n' "$path" |
211                 sed -e '
212                         s|//*|/|g
213                         s|^\(\./\)*||
214                         s|/\./|/|g
215                         :start
216                         s|\([^/]*\)/\.\./||
217                         tstart
218                         s|/*$||
219                 ')
220         git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
221         die "'$path' already exists in the index"
223         if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
224         then
225                 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
226                 echo >&2 $path &&
227                 echo >&2 "Use -f if you really want to add it."
228                 exit 1
229         fi
231         # perhaps the path exists and is already a git repo, else clone it
232         if test -e "$path"
233         then
234                 if test -d "$path"/.git -o -f "$path"/.git
235                 then
236                         echo "Adding existing repo at '$path' to the index"
237                 else
238                         die "'$path' already exists and is not a valid git repo"
239                 fi
241                 case "$repo" in
242                 ./*|../*)
243                         url=$(resolve_relative_url "$repo") || exit
244                     ;;
245                 *)
246                         url="$repo"
247                         ;;
248                 esac
249                 git config submodule."$path".url "$url"
250         else
252                 module_clone "$path" "$realrepo" "$reference" || exit
253                 (
254                         clear_local_git_env
255                         cd "$path" &&
256                         # ash fails to wordsplit ${branch:+-b "$branch"...}
257                         case "$branch" in
258                         '') git checkout -f -q ;;
259                         ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
260                         esac
261                 ) || die "Unable to checkout submodule '$path'"
262         fi
264         git add $force "$path" ||
265         die "Failed to add submodule '$path'"
267         git config -f .gitmodules submodule."$path".path "$path" &&
268         git config -f .gitmodules submodule."$path".url "$repo" &&
269         git add --force .gitmodules ||
270         die "Failed to register submodule '$path'"
274 # Execute an arbitrary command sequence in each checked out
275 # submodule
277 # $@ = command to execute
279 cmd_foreach()
281         # parse $args after "submodule ... foreach".
282         while test $# -ne 0
283         do
284                 case "$1" in
285                 -q|--quiet)
286                         GIT_QUIET=1
287                         ;;
288                 --recursive)
289                         recursive=1
290                         ;;
291                 -*)
292                         usage
293                         ;;
294                 *)
295                         break
296                         ;;
297                 esac
298                 shift
299         done
301         toplevel=$(pwd)
303         module_list |
304         while read mode sha1 stage path
305         do
306                 if test -e "$path"/.git
307                 then
308                         say "Entering '$prefix$path'"
309                         name=$(module_name "$path")
310                         (
311                                 prefix="$prefix$path/"
312                                 clear_local_git_env
313                                 cd "$path" &&
314                                 eval "$@" &&
315                                 if test -n "$recursive"
316                                 then
317                                         cmd_foreach "--recursive" "$@"
318                                 fi
319                         ) ||
320                         die "Stopping at '$path'; script returned non-zero status."
321                 fi
322         done
326 # Register submodules in .git/config
328 # $@ = requested paths (default to all)
330 cmd_init()
332         # parse $args after "submodule ... init".
333         while test $# -ne 0
334         do
335                 case "$1" in
336                 -q|--quiet)
337                         GIT_QUIET=1
338                         ;;
339                 --)
340                         shift
341                         break
342                         ;;
343                 -*)
344                         usage
345                         ;;
346                 *)
347                         break
348                         ;;
349                 esac
350                 shift
351         done
353         module_list "$@" |
354         while read mode sha1 stage path
355         do
356                 # Skip already registered paths
357                 name=$(module_name "$path") || exit
358                 url=$(git config submodule."$name".url)
359                 test -z "$url" || continue
361                 url=$(git config -f .gitmodules submodule."$name".url)
362                 test -z "$url" &&
363                 die "No url found for submodule path '$path' in .gitmodules"
365                 # Possibly a url relative to parent
366                 case "$url" in
367                 ./*|../*)
368                         url=$(resolve_relative_url "$url") || exit
369                         ;;
370                 esac
372                 git config submodule."$name".url "$url" ||
373                 die "Failed to register url for submodule path '$path'"
375                 upd="$(git config -f .gitmodules submodule."$name".update)"
376                 test -z "$upd" ||
377                 git config submodule."$name".update "$upd" ||
378                 die "Failed to register update mode for submodule path '$path'"
380                 say "Submodule '$name' ($url) registered for path '$path'"
381         done
385 # Update each submodule path to correct revision, using clone and checkout as needed
387 # $@ = requested paths (default to all)
389 cmd_update()
391         # parse $args after "submodule ... update".
392         orig_flags=
393         while test $# -ne 0
394         do
395                 case "$1" in
396                 -q|--quiet)
397                         GIT_QUIET=1
398                         ;;
399                 -i|--init)
400                         init=1
401                         ;;
402                 -N|--no-fetch)
403                         nofetch=1
404                         ;;
405                 -f|--force)
406                         force=$1
407                         ;;
408                 -r|--rebase)
409                         update="rebase"
410                         ;;
411                 --reference)
412                         case "$2" in '') usage ;; esac
413                         reference="--reference=$2"
414                         orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
415                         shift
416                         ;;
417                 --reference=*)
418                         reference="$1"
419                         ;;
420                 -m|--merge)
421                         update="merge"
422                         ;;
423                 --recursive)
424                         recursive=1
425                         ;;
426                 --)
427                         shift
428                         break
429                         ;;
430                 -*)
431                         usage
432                         ;;
433                 *)
434                         break
435                         ;;
436                 esac
437                 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
438                 shift
439         done
441         if test -n "$init"
442         then
443                 cmd_init "--" "$@" || return
444         fi
446         cloned_modules=
447         module_list "$@" | {
448         err=
449         while read mode sha1 stage path
450         do
451                 if test "$stage" = U
452                 then
453                         echo >&2 "Skipping unmerged submodule $path"
454                         continue
455                 fi
456                 name=$(module_name "$path") || exit
457                 url=$(git config submodule."$name".url)
458                 update_module=$(git config submodule."$name".update)
459                 if test -z "$url"
460                 then
461                         # Only mention uninitialized submodules when its
462                         # path have been specified
463                         test "$#" != "0" &&
464                         say "Submodule path '$path' not initialized" &&
465                         say "Maybe you want to use 'update --init'?"
466                         continue
467                 fi
469                 if ! test -d "$path"/.git -o -f "$path"/.git
470                 then
471                         module_clone "$path" "$url" "$reference"|| exit
472                         cloned_modules="$cloned_modules;$name"
473                         subsha1=
474                 else
475                         subsha1=$(clear_local_git_env; cd "$path" &&
476                                 git rev-parse --verify HEAD) ||
477                         die "Unable to find current revision in submodule path '$path'"
478                 fi
480                 if ! test -z "$update"
481                 then
482                         update_module=$update
483                 fi
485                 if test "$subsha1" != "$sha1"
486                 then
487                         subforce=$force
488                         # If we don't already have a -f flag and the submodule has never been checked out
489                         if test -z "$subsha1" -a -z "$force"
490                         then
491                                 subforce="-f"
492                         fi
494                         if test -z "$nofetch"
495                         then
496                                 # Run fetch only if $sha1 isn't present or it
497                                 # is not reachable from a ref.
498                                 (clear_local_git_env; cd "$path" &&
499                                         ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
500                                          test -z "$rev") || git-fetch)) ||
501                                 die "Unable to fetch in submodule path '$path'"
502                         fi
504                         # Is this something we just cloned?
505                         case ";$cloned_modules;" in
506                         *";$name;"*)
507                                 # then there is no local change to integrate
508                                 update_module= ;;
509                         esac
511                         case "$update_module" in
512                         rebase)
513                                 command="git rebase"
514                                 action="rebase"
515                                 msg="rebased onto"
516                                 ;;
517                         merge)
518                                 command="git merge"
519                                 action="merge"
520                                 msg="merged in"
521                                 ;;
522                         *)
523                                 command="git checkout $subforce -q"
524                                 action="checkout"
525                                 msg="checked out"
526                                 ;;
527                         esac
529                         if (clear_local_git_env; cd "$path" && $command "$sha1")
530                         then
531                                 say "Submodule path '$path': $msg '$sha1'"
532                         else
533                                 case $action in
534                                 rebase|merge)
535                                         die_with_status 2 "Unable to $action '$sha1' in submodule path '$path'"
536                                         ;;
537                                 *)
538                                         err="${err};Failed to $action in submodule path '$path'"
539                                         continue
540                                         ;;
541                                 esac
542                         fi
543                 fi
545                 if test -n "$recursive"
546                 then
547                         (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
548                         res=$?
549                         if test $res -gt 0
550                         then
551                                 if test $res -eq 1
552                                 then
553                                         err="${err};Failed to recurse into submodule path '$path'"
554                                         continue
555                                 else
556                                         die_with_status $res "Failed to recurse into submodule path '$path'"
557                                 fi
558                         fi
559                 fi
560         done
562         if test -n "$err"
563         then
564                 OIFS=$IFS
565                 IFS=';'
566                 for e in $err
567                 do
568                         if test -n "$e"
569                         then
570                                 echo >&2 "$e"
571                         fi
572                 done
573                 IFS=$OIFS
574                 exit 1
575         fi
576         }
579 set_name_rev () {
580         revname=$( (
581                 clear_local_git_env
582                 cd "$1" && {
583                         git describe "$2" 2>/dev/null ||
584                         git describe --tags "$2" 2>/dev/null ||
585                         git describe --contains "$2" 2>/dev/null ||
586                         git describe --all --always "$2"
587                 }
588         ) )
589         test -z "$revname" || revname=" ($revname)"
592 # Show commit summary for submodules in index or working tree
594 # If '--cached' is given, show summary between index and given commit,
595 # or between working tree and given commit
597 # $@ = [commit (default 'HEAD'),] requested paths (default all)
599 cmd_summary() {
600         summary_limit=-1
601         for_status=
602         diff_cmd=diff-index
604         # parse $args after "submodule ... summary".
605         while test $# -ne 0
606         do
607                 case "$1" in
608                 --cached)
609                         cached="$1"
610                         ;;
611                 --files)
612                         files="$1"
613                         ;;
614                 --for-status)
615                         for_status="$1"
616                         ;;
617                 -n|--summary-limit)
618                         if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
619                         then
620                                 :
621                         else
622                                 usage
623                         fi
624                         shift
625                         ;;
626                 --)
627                         shift
628                         break
629                         ;;
630                 -*)
631                         usage
632                         ;;
633                 *)
634                         break
635                         ;;
636                 esac
637                 shift
638         done
640         test $summary_limit = 0 && return
642         if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
643         then
644                 head=$rev
645                 test $# = 0 || shift
646         elif test -z "$1" -o "$1" = "HEAD"
647         then
648                 # before the first commit: compare with an empty tree
649                 head=$(git hash-object -w -t tree --stdin </dev/null)
650                 test -z "$1" || shift
651         else
652                 head="HEAD"
653         fi
655         if [ -n "$files" ]
656         then
657                 test -n "$cached" &&
658                 die "--cached cannot be used with --files"
659                 diff_cmd=diff-files
660                 head=
661         fi
663         cd_to_toplevel
664         # Get modified modules cared by user
665         modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
666                 sane_egrep '^:([0-7]* )?160000' |
667                 while read mod_src mod_dst sha1_src sha1_dst status name
668                 do
669                         # Always show modules deleted or type-changed (blob<->module)
670                         test $status = D -o $status = T && echo "$name" && continue
671                         # Also show added or modified modules which are checked out
672                         GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
673                         echo "$name"
674                 done
675         )
677         test -z "$modules" && return
679         git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
680         sane_egrep '^:([0-7]* )?160000' |
681         cut -c2- |
682         while read mod_src mod_dst sha1_src sha1_dst status name
683         do
684                 if test -z "$cached" &&
685                         test $sha1_dst = 0000000000000000000000000000000000000000
686                 then
687                         case "$mod_dst" in
688                         160000)
689                                 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
690                                 ;;
691                         100644 | 100755 | 120000)
692                                 sha1_dst=$(git hash-object $name)
693                                 ;;
694                         000000)
695                                 ;; # removed
696                         *)
697                                 # unexpected type
698                                 echo >&2 "unexpected mode $mod_dst"
699                                 continue ;;
700                         esac
701                 fi
702                 missing_src=
703                 missing_dst=
705                 test $mod_src = 160000 &&
706                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
707                 missing_src=t
709                 test $mod_dst = 160000 &&
710                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
711                 missing_dst=t
713                 total_commits=
714                 case "$missing_src,$missing_dst" in
715                 t,)
716                         errmsg="  Warn: $name doesn't contain commit $sha1_src"
717                         ;;
718                 ,t)
719                         errmsg="  Warn: $name doesn't contain commit $sha1_dst"
720                         ;;
721                 t,t)
722                         errmsg="  Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
723                         ;;
724                 *)
725                         errmsg=
726                         total_commits=$(
727                         if test $mod_src = 160000 -a $mod_dst = 160000
728                         then
729                                 range="$sha1_src...$sha1_dst"
730                         elif test $mod_src = 160000
731                         then
732                                 range=$sha1_src
733                         else
734                                 range=$sha1_dst
735                         fi
736                         GIT_DIR="$name/.git" \
737                         git rev-list --first-parent $range -- | wc -l
738                         )
739                         total_commits=" ($(($total_commits + 0)))"
740                         ;;
741                 esac
743                 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
744                 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
745                 if test $status = T
746                 then
747                         if test $mod_dst = 160000
748                         then
749                                 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
750                         else
751                                 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
752                         fi
753                 else
754                         echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
755                 fi
756                 if test -n "$errmsg"
757                 then
758                         # Don't give error msg for modification whose dst is not submodule
759                         # i.e. deleted or changed to blob
760                         test $mod_dst = 160000 && echo "$errmsg"
761                 else
762                         if test $mod_src = 160000 -a $mod_dst = 160000
763                         then
764                                 limit=
765                                 test $summary_limit -gt 0 && limit="-$summary_limit"
766                                 GIT_DIR="$name/.git" \
767                                 git log $limit --pretty='format:  %m %s' \
768                                 --first-parent $sha1_src...$sha1_dst
769                         elif test $mod_dst = 160000
770                         then
771                                 GIT_DIR="$name/.git" \
772                                 git log --pretty='format:  > %s' -1 $sha1_dst
773                         else
774                                 GIT_DIR="$name/.git" \
775                                 git log --pretty='format:  < %s' -1 $sha1_src
776                         fi
777                         echo
778                 fi
779                 echo
780         done |
781         if test -n "$for_status"; then
782                 if [ -n "$files" ]; then
783                         echo "# Submodules changed but not updated:"
784                 else
785                         echo "# Submodule changes to be committed:"
786                 fi
787                 echo "#"
788                 sed -e 's|^|# |' -e 's|^# $|#|'
789         else
790                 cat
791         fi
794 # List all submodules, prefixed with:
795 #  - submodule not initialized
796 #  + different revision checked out
798 # If --cached was specified the revision in the index will be printed
799 # instead of the currently checked out revision.
801 # $@ = requested paths (default to all)
803 cmd_status()
805         # parse $args after "submodule ... status".
806         orig_flags=
807         while test $# -ne 0
808         do
809                 case "$1" in
810                 -q|--quiet)
811                         GIT_QUIET=1
812                         ;;
813                 --cached)
814                         cached=1
815                         ;;
816                 --recursive)
817                         recursive=1
818                         ;;
819                 --)
820                         shift
821                         break
822                         ;;
823                 -*)
824                         usage
825                         ;;
826                 *)
827                         break
828                         ;;
829                 esac
830                 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
831                 shift
832         done
834         module_list "$@" |
835         while read mode sha1 stage path
836         do
837                 name=$(module_name "$path") || exit
838                 url=$(git config submodule."$name".url)
839                 displaypath="$prefix$path"
840                 if test "$stage" = U
841                 then
842                         say "U$sha1 $displaypath"
843                         continue
844                 fi
845                 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
846                 then
847                         say "-$sha1 $displaypath"
848                         continue;
849                 fi
850                 set_name_rev "$path" "$sha1"
851                 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
852                 then
853                         say " $sha1 $displaypath$revname"
854                 else
855                         if test -z "$cached"
856                         then
857                                 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
858                                 set_name_rev "$path" "$sha1"
859                         fi
860                         say "+$sha1 $displaypath$revname"
861                 fi
863                 if test -n "$recursive"
864                 then
865                         (
866                                 prefix="$displaypath/"
867                                 clear_local_git_env
868                                 cd "$path" &&
869                                 eval cmd_status "$orig_args"
870                         ) ||
871                         die "Failed to recurse into submodule path '$path'"
872                 fi
873         done
876 # Sync remote urls for submodules
877 # This makes the value for remote.$remote.url match the value
878 # specified in .gitmodules.
880 cmd_sync()
882         while test $# -ne 0
883         do
884                 case "$1" in
885                 -q|--quiet)
886                         GIT_QUIET=1
887                         shift
888                         ;;
889                 --)
890                         shift
891                         break
892                         ;;
893                 -*)
894                         usage
895                         ;;
896                 *)
897                         break
898                         ;;
899                 esac
900         done
901         cd_to_toplevel
902         module_list "$@" |
903         while read mode sha1 stage path
904         do
905                 name=$(module_name "$path")
906                 url=$(git config -f .gitmodules --get submodule."$name".url)
908                 # Possibly a url relative to parent
909                 case "$url" in
910                 ./*|../*)
911                         url=$(resolve_relative_url "$url") || exit
912                         ;;
913                 esac
915                 say "Synchronizing submodule url for '$name'"
916                 git config submodule."$name".url "$url"
918                 if test -e "$path"/.git
919                 then
920                 (
921                         clear_local_git_env
922                         cd "$path"
923                         remote=$(get_default_remote)
924                         git config remote."$remote".url "$url"
925                 )
926                 fi
927         done
930 # This loop parses the command line arguments to find the
931 # subcommand name to dispatch.  Parsing of the subcommand specific
932 # options are primarily done by the subcommand implementations.
933 # Subcommand specific options such as --branch and --cached are
934 # parsed here as well, for backward compatibility.
936 while test $# != 0 && test -z "$command"
937 do
938         case "$1" in
939         add | foreach | init | update | status | summary | sync)
940                 command=$1
941                 ;;
942         -q|--quiet)
943                 GIT_QUIET=1
944                 ;;
945         -b|--branch)
946                 case "$2" in
947                 '')
948                         usage
949                         ;;
950                 esac
951                 branch="$2"; shift
952                 ;;
953         --cached)
954                 cached="$1"
955                 ;;
956         --)
957                 break
958                 ;;
959         -*)
960                 usage
961                 ;;
962         *)
963                 break
964                 ;;
965         esac
966         shift
967 done
969 # No command word defaults to "status"
970 test -n "$command" || command=status
972 # "-b branch" is accepted only by "add"
973 if test -n "$branch" && test "$command" != add
974 then
975         usage
976 fi
978 # "--cached" is accepted only by "status" and "summary"
979 if test -n "$cached" && test "$command" != status -a "$command" != summary
980 then
981         usage
982 fi
984 "cmd_$command" "$@"